*******************************************************************************
*  PROGRAM:      Music.prg
*
*  WRITTEN BY:   Borland Samples Group
*
*  DATE:         4/94
*
*  UPDATED:      7/6/94
*
*  VERSION:      dBASE FOR WINDOWS 5.0
*
*  DESCRIPTION:  This program is an illustration of how a record store,
*                Musical Methods, displays its music collection information.
*                This program will allow you to view the available music
*                in various orders, look at separate tables of music categories,
*                sales rankings, and media types available.  You can search for
*                information, and look at the available data in various
*                formats.  This file is both the starting program and the
*                procedure file for all forms called in the application.
*
*  PARAMETERS:   None
*
*  CALLS:        Start.wfm       (inital form)
*
*  USAGE:        DO Music
*
*******************************************************************************
#include "Music.h"
#include <Messdlg.h>
#include <Enum.h>

set talk off

*** Public Variables
* start         -- temporary initial form
* savePath      -- saves old path
* oldFrameText  -- saves old frame text
* focusForm     -- form currently in focus
* windowCnt     -- count of currently open windows (for Windows menu)

*** Save Environment

public savePath,oldFrameText
savePath = set("path")
oldFrameText = _app.framewin.text


*** Set Environment

set path to &_dbwinhome.Samples    && For buttons.cc and messdlg.prg
_app.framewin.text = "Musical Methods"  && Application title
set help to music.hlp                   && Help file for the program

*** Procedure Files

set procedure to program(1) additive

*** Public Variables

public start,focusForm,windowCnt

focusForm = .f.
windowCnt = 0

* Initial form
shell(.f.,.t.)                && Close dBASEWIN desktop windows
start = new tempForm()
start.Open()



******************************* Classes ***************************************

*******************************************************************************
*******************************************************************************
CLASS TEMPFORM OF FORM

*******************************************************************************
   this.top = 71.41
   this.menuFile = "Start.mnu"
   this.StatusMessage = "Press Shift-F1 for Help."

   procedure OnOpen
   do Start.wfm
ENDCLASS




******************************************************************************
procedure ViewOnGotFocus

* OnGotFocus routine for all view forms
******************************************************************************
if .not. empty(focusForm) .and. focusForm.windowCnt <> this.windowCnt
   focusForm.winMenu.checked = .f.
   if type("focusForm.Root.WindowMenu") <> "U"
      focusForm.Root.WindowMenu.parent = this.Root
   endif
endif
this.winMenu.checked = .t.       && Check the corresponding Windows menu prompt
focusForm = this

*******************************************************************************
procedure ViewOnLostFocus

* OnLostFocus routine for all view forms
*******************************************************************************
this.winMenu.checked = .f.    && Uncheck the corresponding Windows menu prompt


********* Views procedures

*******************************************************************************
procedure CorrespondingItems
*******************************************************************************
private key
if .not. form.MusicIsOpen              && Check if browse is already open
   form.MusicIsOpen = .t.
endif

DEFINE RECTANGLE DIVIDERRECT OF FORM;
    PROPERTY;
      ColorNormal form.colorNormal,;
      Text "",;
      Height         form.height,;
      Width          0.34,;
      Top          0.00,;
      Left         form.width,;
      Border .T.

DEFINE BROWSE ITEMSBROWSE OF FORM;
    PROPERTY;
      ShowRecNo .F.,;
      Modify .F.,;
      Toggle .F.,;
      Width         MAX_FORM_WIDTH - form.dividerRect.left,;
      Top           1.01,;
      Left          form.dividerRect.left + .5,;
      Height        form.height - 3,;
      Alias "Music",;
      Fields "Music->Artist, Music->Title, Music->Rank",;
      ColorNormal "r/w",;
      FontSize          8.00,;
      FontName "MS Sans Serif",;
      FontBold .F.,;
      Delete .F.


this.text     = "No &Items"
this.helpId   = "No Items"
this.OnClick  = NoCorrespItems
this.StatusMessage = "Remove displayed browse of items.  Press F1 for Help."
form.width    = MAX_FORM_WIDTH
form.left     = 0.00
go recno()

*******************************************************************************
procedure NoCorrespItems
*******************************************************************************
this.text          = "&Items..."
this.helpId        = "Items"
this.OnClick       = CorrespondingItems
this.statusMessage = "Show available items that match the current selection.  Press F1 for Help."
form.width         = form.dividerRect.left - 1
form.left          = 27.03
form.dividerRect.Release()
form.itemsBrowse.Release()



*******************************************************************************
procedure SizeForm(nType, width, height)

* Resize form controls as the form gets resized.
******************************************************************************
if form.windowState <> WINDOWSTATE_MINIMIZED          && if not minimized
   if .not. form.MusicIsOpen         && If only have a listbox
      form.descriptList.height = height - 9
   endif

   form.itemsButton.top          = PB_ROW(height)
   form.closeFormButton.top      = PB_ROW(height)
   form.logoImage.top            = height - 4.53
   form.listRect.height          = height - 6
   form.descriptList.height      = height - 8
   if form.itemsButton.text = "No &Items"
      form.dividerRect.height = height
      form.itemsBrowse.height = height - 2
      form.width = form.itemsBrowse.left + form.itemsBrowse.width + 1
   else
      form.width = form.descriptList.left + form.descriptList.width + 3
   endif
endif







************* Windows


*******************************************************************************
procedure AddWindow(newForm)
*******************************************************************************
private strWin,temp,temp2
if .not. empty(focusForm)           && If another form is present and has focus
                                    && Reassign its Windows menu
   focusForm.Root.WindowMenu.parent = newForm.Root
   focusForm.OnLostFocus()
else                                && Otherwise create a Windows menu
   define menu WindowMenu of newForm.Root;
      property;
         text "&Windows"
endif
windowCnt = windowCnt + 1           && Increment current window count
newForm.windowCnt = windowCnt
MakeTitle(newForm,newForm.text)     && Add count to form title
strWin = ltrim(str(windowCnt))
temp = newForm
define menu window&strWin of temp.root.windowMenu;
   property;
      text temp.text,;
      checked .t.,;
      OnClick SetThisFocus;
   custom;
      form temp                     && Menu points back to form for getting focus
temp.winMenu = temp.root.windowMenu.window&strWin  && form directly to menu
                                                   && menu directly to form
focusForm = temp                    && This form is now in focus

******************************************************************************
procedure DeleteWindow(f)
******************************************************************************
private strWin,i,curMenu,curForm,fRootWindowMenu
curMenu = .f.
f.winMenu.Release()
f.OnGotFocus = .f.
fRootWindowMenu = f.root.windowMenu
strWin = ltrim(str(f.windowCnt))
for i = f.windowCnt + 1 to windowCnt    && change numbers on menus
   strWin = ltrim(str(i))
   if type("fRootWindowMenu.window&strWin") = "O"  && not Deleted
      curMenu = fRootWindowMenu.window&strWin
      curForm = curMenu.form
      curForm.windowCnt = curForm.windowCnt - 1  && Decrement windowCnt
      MakeTitle(curForm,curForm.text)            && for forms after deleted one
      curMenu.text = curForm.text
      curMenu.name = "Window" + ltrim(str(curForm.windowCnt))
   endif
next i
windowCnt = windowCnt - 1       && Decrement count for window names
do case
   case windowCnt = 0           && No more windows at all
      focusForm = .f.
   case .not. empty(curMenu)    && More windows following closed one
      focusForm = curMenu.form
                                && Reassign its Window menu
      f.root.windowMenu.parent = focusForm.Root
   case empty(curMenu)          && This was the last window on the menu
      focusForm = fRootWindowMenu.window1.form
      fRootWindowMenu.parent = focusForm.Root
                                && Reassign its Window menu
endcase



******************************************************************************
procedure SetThisFocus
******************************************************************************
this.form.SetFocus()

******************************************************************************
procedure DisableWindowing(f)

* This is called when a view form is run standalone, so that no
* other view forms can be opened.
******************************************************************************
f.root.viewMenu.musicView.enabled = .f.
f.root.viewMenu.categories.enabled = .f.
f.root.viewMenu.rankings.enabled = .f.
f.root.viewMenu.mediatypes.enabled = .f.


*** Utility procedures *******************************************************

******************************************************************************
procedure MakeTitle(f,fTitle)
* Create a title for form f that contains its windowCnt
******************************************************************************
local cntLocation
if _app.framewin.text = "Musical Methods"
   cntLocation = at("(",fTitle)       && Make sure windowCnt appears only once
   f.text = " (" + ltrim(str(f.windowCnt)) + ") " + ;
            iif(cntLocation = 2,;     && If title already contains windowCnt
                substr(fTitle,cntLocation + 4),;
                ftitle)
else
   f.text = fTitle                    && No windowCnt in title if form is
endif                                 && running standalone


******************************************************************************
procedure SetTopBotRecs(form)
******************************************************************************
private f
f = form
go top
f.firstRec = recno()
go bottom
f.lastRec = recno()
go f.firstRec



******************************************************************************
procedure SetEnvironment
******************************************************************************
set talk off
set exact off



******************************************************************************
function FormatStr(string)
*
* Could have 0 or more parameters.
* This function will replace occurrences of "%<n>" with the corresponding
* parameter string.  It will also replace all occurrences of "\n" with a
* Carriage Return, and all occurrences of "\t" with a Tab.
*
* Example: x = FormatStr("Hello \n %1", "World") && prints Hello World on 2
*                                                && lines
******************************************************************************
#define ENTER  chr(13)
#define TAB    chr(9)
local i, strPos, strCnt, tmpStr

tmpStr = string
for i = 2 to argc()    && while have something to search for
   tmpStr = StrTran(tmpStr, "%" + ltrim(str(i - 1)), argv(i))
next
tmpStr = StrTran(tmpStr, "\n", ENTER)
tmpStr = StrTran(tmpStr, "\t", TAB)

return tmpStr


******************************************************************************
function StrTran(string,curStr,repStr)
*
* Replaces all occurrences of curStr in string with repStr
******************************************************************************
local strPos, lenCurStr, tmpStr
tmpStr = string
lenCurStr = len(curStr)
strPos = at(curStr,tmpStr)
do while strPos > 0
   tmpStr = stuff(tmpStr, strPos, lenCurStr, repStr)
   strPos = at(curStr,tmpStr)
enddo
return tmpStr




